#include <iostream>
#include <cmath>

double PTAT_grad = 0.021429857239127;
double PTAT_offset = 2125.415283203125;
int gradscale = 24;
int VddScGrad = 15;
int VddScOff = 20;
float Vdd_th1 = 48515;
float Vdd_th2 = 48301;
float PTAT_th1 = 38120;
float PTAT_th2 = 49235;
int epsilon = 100;
int GlobalGain = 8500;
int PCSCALEVAL = pow(10,8);
float PixC_max = 68268464;
float PixC_min = 44561748;


int ThGrad[16][16] =
	{{13266,4717,11285,15849,10796,12406,11893,13408,16521,11191,9870,8944,15937,19487,14900,14976},
	{19457,9823,10012,14487,12317,17064,17588,19180,14516,13962,12871,16975,12600,16556,17087,18178},
	{16433,11291,14422,13390,14074,14133,13373,17347,23231,19522,19304,15006,15259,17842,14752,13095},
	{15937,15601,15130,15961,16527,17034,17134,17140,18667,20690,16604,16828,16002,15737,16203,16875},
	{17323,7270,14192,18874,13473,15495,14947,14670,18520,14086,14098,12028,17217,22529,16173,16639},
	{24446,13178,12323,16657,15990,18072,20566,16981,17069,15230,16268,18207,13885,19151,18608,19092},
	{18714,11975,14982,16822,17081,16114,16722,17052,21026,17441,19599,14970,16161,19528,16704,13243},
	{15985,16262,16315,16810,16527,18078,18661,17824,17547,17954,18089,15985,16102,16150,17830,16456},
	{15654,15572,16769,18072,16150,16615,18885,17954,17518,17677,17111,17470,18968,17582,17588,16781},
	{17193,13809,11167,15283,17577,17258,19410,21497,14900,20495,13667,18084,20059,18939,16745,17571},	
	{18561,15648,19546,12771,17812,18019,19758,15135,13809,12577,15371,12282,24375,14493,20141,19611},
	{21710,14263,13160,13479,12700,17394,16881,17577,13072,9487,15678,10289,15619,17877,19334,14628},
	{16032,16981,17016,18408,16315,16869,16232,17683,17630,16439,17358,18031,19045,16810,17606,16881},
	{17211,13090,10554,17382,17246,18013,18720,19546,15159,20908,12494,19446,19510,19823,17995,17759},
	{18361,17010,21138,13597,17860,18673,17435,14906,13172,13561,14127,11952,21232,14976,19198,18249},
	{21592,14009,12140,10672,12488,17128,13656,16515,11722,9682,12818,8302,11716,16391,17087,13514}};

int ThOffset[16][16] = 
	{{-70,-21,-56,-93,-61,-69,-73,-67,-88,-42,-21,-58,-88,-111,-87,-78},
	{-128,-66,-59,-85,-76,-99,-95,-87,-75,-80,-81,-84,-58,-84,-86,-100},
	{-100,-55,-75,-83,-75,-84,-74,-90,-123,-92,-110,-83,-80,-91,-68,-49},
	{-89,-89,-87,-88,-89,-90,-89,-89,-91,-95,-86,-86,-83,-81,-81,-80},
	{-83,-29,-64,-100,-67,-75,-79,-69,-91,-61,-58,-64,-90,-116,-89,-79},
	{-139,-75,-64,-90,-82,-96,-98,-81,-78,-81,-87,-84,-59,-88,-85,-97},
	{-105,-56,-75,-90,-81,-88,-78,-88,-117,-87,-108,-82,-80,-93,-70,-46},
	{-90,-90,-88,-89,-88,-90,-91,-89,-88,-89,-88,-78,-82,-80,-83,-78},
	{-86,-87,-88,-91,-84,-85,-90,-87,-87,-86,-85,-85,-87,-82,-82,-76},
	{-98,-73,-48,-73,-84,-87,-95,-108,-69,-100,-57,-83,-101,-94,-74,-84},
	{-107,-94,-114,-65,-93,-93,-85,-69,-59,-53,-67,-48,-113,-63,-96,-87},
	{-127,-79,-69,-62,-62,-88,-78,-93,-51,-28,-70,-33,-69,-86,-85,-66},
	{-84,-90,-88,-91,-84,-85,-84,-86,-86,-83,-84,-86,-87,-79,-82,-73},
	{-97,-71,-46,-77,-83,-88,-93,-103,-70,-100,-53,-87,-99,-97,-77,-83},
	{-105,-97,-118,-66,-93,-95,-79,-68,-57,-55,-64,-47,-107,-64,-94,-82},
	{-128,-79,-67,-56,-61,-89,-71,-92,-50,-33,-66,-32,-66,-89,-88,-72}};


int VddCompGrad[16][16] = 
	{{-717,-519,82,212,-251,12,-394,377,445,-1291,-298,-1208,-793,-604,-858,-127},
	{207,-1099,-1627,-1458,-1273,-263,-519,-683,-262,-795,-1493,363,-456,40,-272,-991},
	{-444,-336,-730,-402,-402,-1692,-1002,107,689,-168,-944,-1220,-501,-588,-616,-882},
	{-23,82,-612,-736,-1079,-1023,-862,170,144,822,-478,-1281,-1139,-842,233,-558},
	{-717,-519,82,212,-251,12,-394,377,445,-1291,-298,-1208,-793,-604,-858,-127},
	{207,-1099,-1627,-1458,-1273,-263,-519,-683,-262,-795,-1493,363,-456,40,-272,-991},
	{-444,-336,-730,-402,-402,-1692,-1002,107,689,-168,-944,-1220,-501,-588,-616,-882},
	{-23,82,-612,-736,-1079,-1023,-862,170,144,822,-478,-1281,-1139,-842,233,-558},
	{-353,-558,-217,-633,-840,-1373,-1454,-230,41,-1225,-863,-524,673,-1200,-316,-821},
	{-324,-315,18,-348,243,-477,-216,-370,-770,-687,119,-541,-360,-130,-655,-1015},
	{-422,-1641,-1162,-1547,-463,-1246,-468,-772,-730,-326,-642,-520,13,-838,-1180,0},
	{-242,-1103,-1398,-790,-756,-965,-546,-734,-579,-885,-537,-1323,-1289,128,-595,-962},
	{-353,-558,-217,-633,-840,-1373,-1454,-230,41,-1225,-863,-524,673,-1200,-316,-821},
	{-324,-315,18,-348,243,-477,-216,-370,-770,-687,119,-541,-360,-130,-655,-1015},
	{-422,-1641,-1162,-1547,-463,-1246,-468,-772,-730,-326,-642,-520,13,-838,-1180,0},	
	{-242,-1103,-1398,-790,-756,-965,-546,-734,-579,-885,-537,-1323,-1289,128,-595,-962}};


int VddCompOff[16][16] =
	{{517,541,-656,-765,-208,-513,-154,-871,-1437,1386,7,939,170,-148,338,-505},
	{-1245,864,1422,1307,919,-659,85,452,-325,205,1132,-1130,102,-743,-404,512},
	{-408,-55,297,16,-153,1686,847,-836,-1757,-365,240,801,-21,-22,156,799},
	{-691,-826,-18,261,808,715,631,-966,-796,-1904,-91,906,614,342,-1009,195},
	{517,541,-656,-765,-208,-513,-154,-871,-1437,1386,7,939,170,-148,338,-505},
	{-1245,864,1422,1307,919,-659,85,452,-325,205,1132,-1130,102,-743,-404,512},
	{-408,-55,297,16,-153,1686,847,-836,-1757,-365,240,801,-21,-22,156,799},
	{-691,-826,-18,261,808,715,631,-966,-796,-1904,-91,906,614,342,-1009,195},
	{-58,-87,-450,62,533,1223,1176,-424,-681,860,513,57,-1597,976,-225,452},
	{-133,-177,-280,145,-857,77,-388,-330,631,45,-701,130,-330,-623,364,691},
	{-200,1585,445,1577,-199,985,114,392,633,51,276,426,-813,563,710,-572},
	{-536,960,1240,629,463,436,117,163,254,859,180,1516,1112,-936,196,694},
	{-58,-87,-450,62,533,1223,1176,-424,-681,860,513,57,-1597,976,-225,452},
	{-133,-177,-280,145,-857,77,-388,-330,631,45,-701,130,-330,-623,364,691},
	{-200,1585,445,1577,-199,985,114,392,633,51,276,426,-813,563,710,-572},
	{-536,960,1240,629,463,436,117,163,254,859,180,1516,1112,-936,196,694}};
	

int P[16][16] = 
	{{19558,27367,32251,35138,37721,39647,34782,36168,37968,17373,0,34055,31631,25579,20847,14211},
	{30110,35372,37805,40841,42225,44262,43398,46209,44760,41525,42697,42366,35905,32140,31432,22644},
	{31132,40789,44922,47096,50026,45040,50692,51591,46897,46678,47159,43595,41885,37194,35630,25462},
	{40724,46916,46867,52379,54537,56372,53539,55033,56675,55505,54117,49989,47054,42981,36567,30104},
	{36703,45909,52033,54991,58209,59730,54798,55620,58122,55372,55890,53616,51375,42649,37689,28645},
	{41877,49032,50759,55127,56143,53304,57338,59946,56850,55399,57321,56135,49071,45277,43099,32959},
	{39962,50738,55310,58456,62569,55887,61119,62517,57202,58488,56057,54848,51597,46289,44585,32379},
	{47860,54160,53580,59801,62096,63297,60959,61907,65535,63654,60633,47461,53909,49149,42739,35766},
	{43910,52761,52601,57107,55020,59602,60156,60343,61280,58671,57857,59571,53792,45048,45961,33668},
	{37146,42736,50788,48910,53441,54636,57642,58658,49269,58864,53924,46318,46968,42379,41557,35043},
	{38999,44919,47657,47542,52865,56036,57021,53612,53859,53822,47587,45758,47508,41754,33664,32456},
	{38023,40641,44539,47592,50950,46517,52221,51068,53585,49442,49577,42508,42683,40562,34438,27458},
	{36839,45445,44288,48079,46154,50053,50801,50783,51135,50024,48755,50898,45366,36645,38475,27023},
	{29037,32392,40116,37591,41932,42128,45851,45739,39518,46595,42331,35654,35349,32690,31994,26389},
	{27680,33040,34874,33739,38461,41690,41810,38822,39479,39432,33183,32132,34131,29757,22754,21071},
	{22749,24111,27197,29588,31741,29339,32612,32298,34183,32090,29880,23886,25528,23941,19030,13666}};

